#version unofficial MegaPOV 0.7;

//Cone Dimensions
#ifndef(Bottom_Cone_Radius)
#declare Bottom_Cone_Radius = 1;
#end
#ifndef(Top_Cone_Radius)
#declare Top_Cone_Radius = 0;
#end
#ifndef(Cone_Height)
#declare Cone_Height = 2;
#end

//Cone Declares
#ifndef(Cone_Color)
#declare Cone_Color = DarkGreen;
#end
#ifndef(Cone_Translate)
#declare Cone_Translate = <0,0,0>;
#end
#ifndef(Cone_Texture)
#declare Cone_Texture = 
texture {Jade}
#end
#ifndef(Cone_Rotate_X)
#declare Cone_Rotate_X=0
#end
#ifndef(Cone_Rotate_Y)
#declare Cone_Rotate_Y=0
#end
#ifndef(Cone_Rotate_Z)
#declare Cone_Rotate_Z=0
#end
#ifndef(Cone_Scale_X)
#declare Cone_Scale_X=1;
#end
#ifndef(Cone_Scale_Y)
#declare Cone_Scale_Y=1;
#end
#ifndef(Cone_Scale_Z)
#declare Cone_Scale_Z=1;
#end
#ifndef(Cone_Scale)
#declare Cone_Scale = 1; 
#end

//Cone Construction
#declare Cone_Longitude = union {
#declare Count = 0;
#while (Count<8)
cylinder {<0,-Cone_Height/2,-Bottom_Cone_Radius>,<0,Cone_Height/2,-Top_Cone_Radius>,.015*Bottom_Cone_Radius
pigment {Cone_Color}
finish {Luminous}
no_shadow
rotate y*Count*45}
#declare Count = Count+1;
#end}
#declare Cone_Latitude = 
union {
torus {Bottom_Cone_Radius,.015*Bottom_Cone_Radius}
torus {(Bottom_Cone_Radius+Top_Cone_Radius)*.66,.015*Bottom_Cone_Radius
translate y*.33*Cone_Height} 
torus {(Bottom_Cone_Radius+Top_Cone_Radius)*.33,.015*Bottom_Cone_Radius
translate y*.66*Cone_Height} 
pigment {Cone_Color}
finish {Luminous}
no_shadow translate -y*Cone_Height/2}

//Render Cone
#if(View=5)
cone {<0,-Cone_Height/2,0>,Bottom_Cone_Radius<0,Cone_Height/2,0>,Top_Cone_Radius
texture {Cone_Texture}
scale <Cone_Scale,Cone_Scale,Cone_Scale>
scale <Cone_Scale_X,1,1>
scale <1,Cone_Scale_Y,1>
scale <1,1,Cone_Scale_Z>
rotate x*Cone_Rotate_X
rotate y*Cone_Rotate_Y
rotate z*Cone_Rotate_Z
translate Cone_Translate}
#else

//Wireframe Cone
union {
object {Cone_Longitude}
object {Cone_Latitude}
scale <Cone_Scale,Cone_Scale,Cone_Scale>
scale <Cone_Scale_X,1,1>
scale <1,Cone_Scale_Y,1>
scale <1,1,Cone_Scale_Z>
rotate x*Cone_Rotate_X
rotate y*Cone_Rotate_Y
rotate z*Cone_Rotate_Z
translate Cone_Translate}
#end



